
function [X, I, Z, Z_gt, BI] = generate_synthetic_data(er, R, N)

    M = 10;             % number of instances per bag
    PM = 1;             % number of positive instances per bag
    d = 1000;            % dimension
    em = 1;             % magnitude of the sparse error

    if ~exist('er', 'var')
        er = 0.05;          % ratio of sparse error
    end
    if ~exist('R', 'var')
        R = 3;              % rank of the subspace
    end
    if ~exist('N', 'var')
        N = 10;             % number of bags
    end
        
    L = randn(d,R);
    X = zeros(d, N*M);
    Z = zeros(1, N*M);
    Z_gt = zeros(1, N*M);
    BI = zeros(1, N*M);
    I = cell(1, N);

    for i = 1:N
        I_ = (i-1)*M+1 : i*M;
        BI(I_) = i;
        I{i} = I_;
        
        % M-PM instances generated by iid gaussian + sparse error
        e=em*( rand(d,M)<=er .* sign(rand(d,M)-0.5) .* rand(d,M) );
        X_ = randn(d, M);
        X_ = X_ ./ repmat(sqrt(sum(X_.^2, 1)), d, 1);   % instance normalization before adding noise
        X(:, I_(1:end)) = X_ + e;
        
        % PM instance of interest with sparse error
        for j = 1:PM
            c = randn(R,1); %
            % c=c/sqrt(sum(c.^2));
%             c=rand(R,1); c=c/sum(c);
            e=em*( rand(d,1)<=er .* sign(rand(d,1)-0.5) .* rand(d,1) );
            x = L*c;
            x = x ./ repmat(sqrt(sum(x.^2, 1)), size(x, 1), 1);     % instance normalization before adding noise
            x = x+e;
            r_gt = ceil(rand()*M);
            X(:,  I_(r_gt) ) = x;
            Z_gt( I_(r_gt) ) = 1;
        end
        % Z_gt(I_) = Z_gt(I_) / sum(Z_gt(I_));
        
        Z( I_( ceil(rand()*M)) ) = 1;
    end
    
